/*
 * chork.java
 * author : sunanekoroom
 * DATE : 2004/01/01 21:20
 * package chork;
 */

import com.nttdocomo.ui.IApplication;
import com.nttdocomo.ui.Graphics;
import com.nttdocomo.ui.Canvas;
import com.nttdocomo.ui.Display;
import com.nttdocomo.io.ConnectionException;
import com.nttdocomo.ui.UIException;
import java.util.Random;

public class chork extends IApplication {
	public void start() {
		CMove cm = new CMove();
		Display.setCurrent(cm);
	}
}

class CMove extends Canvas implements Runnable{
	public int gstatus;
	static public final int GAME_OPEN = 0;
	static public final int GAME_PLAY = 1;
	static public final int GAME_SCORE = 2;
	static public final int GAME_OVER = 3;
	static public final int GAME_DAMAGE = 4;
	static public final int GAME_PAUSE = 5;
	static public final int GAME_HISCORE = 6;

	private int time0;
	private int count;
	private int left;
	private int top;
	private int nc;
	private int tcount;
	private int backpos;

	private static Random rnd = new Random();

	private Thread thread;
	private Player pl;
	private Score sc;
	private Tama t1;
	private Tama t2;
	private Tama t3;
	private Map map;

	CMove(){
		setSoftLabel(SOFT_KEY_1, "Play");
		setSoftLabel(SOFT_KEY_2, "Quit");

		gstatus = GAME_OPEN;
		time0 = 70;
		count = 0;
		nc = 0;
		left = (Display.getWidth() -128)/2;
		top = (Display.getHeight() -128)/2;

		pl = new Player();
		sc = new Score();
		t1 = new Tama();
		t2 = new Tama();
		t3 = new Tama();
		map = new Map();

		thread = new Thread(this);
		thread.start();
	}

	public void run(){
		while(true){
			int m,v;

			if(gstatus == GAME_PLAY){
				--tcount;

				m=0;
				if(time0 > 0){ --time0;}

				if((tcount <= 0)&(nc<3)){ setTama();}

				if((t1.isFree(pl.ppos) == 0)|(t2.isFree(pl.ppos) == 0)|(t3.isFree(pl.ppos) == 0)){
					if(pl.sstatus){
						pl.scount = 6;
						--nc;
					}else{
						time0 = 20;
						gstatus = GAME_DAMAGE;
					}
				}

				if(gstatus == GAME_PLAY){
					pl.an();

					if(t1.tPast() == 1){ --nc; ++m;}
					if(t2.tPast() == 1){ --nc; ++m;}
					if(t3.tPast() == 1){ --nc; ++m;}
					if(m!=0){ if(sc.add(m) == 1){ pl.plusShita();}}
				}
			}else if(gstatus == GAME_DAMAGE){
				--time0;
				if(time0 <= 0){
					gstatus = GAME_PLAY;
					pl.softreset();
					t1.vi = false;
					t2.vi = false;
					t3.vi = false;
					tcount = 15;
					nc = 0;
				}
				else if(time0 == 10){
					if(pl.minusLife() == 0){
						gstatus = GAME_OVER;
						time0 = 60;
						count = 0;
						setSoftLabel(SOFT_KEY_1, "");
					}
				}
			}else if(gstatus == GAME_OVER){
				--time0;
				if(time0 <= 0){
					gstatus = GAME_SCORE;
					t1.vi = false;
					t2.vi = false;
					t3.vi = false;
					time0 = 40;
					sc.score *= 3;
					sc.hsCheck();
					setSoftLabel(SOFT_KEY_1, "");
				}
			}else if(gstatus == GAME_SCORE){
				--time0;
				if( time0 <= 0){
					gstatus = GAME_OPEN;
					time0 = 70;
					setSoftLabel(SOFT_KEY_1, "Play");
				}
			}else if(gstatus == GAME_OPEN){
				--time0;
				if(time0 <= 0){ gstatus=GAME_HISCORE; time0=40; setSoftLabel(SOFT_KEY_1, "");}
			}else if(gstatus == GAME_HISCORE){
				--time0;
				if(time0 <= 0){ gstatus=GAME_OPEN; time0=70;  setSoftLabel(SOFT_KEY_1, "Play");}
			}

			repaint();

			try{
				thread.sleep(85);
			}catch(InterruptedException e){
				break;
			}
		}
	}

	public void paint(Graphics g){
		int n,k;

		g.lock();
		g.clearRect(0, 0, 192, 192);
		if(gstatus == GAME_OPEN){
			g.drawImage(map.back1,left,top);
			if(count < 8){ g.drawImage(map.tea,left+64,top+100);}
			++count;
			if(count >= 16){ count = 0;}
		}else if(gstatus == GAME_SCORE){
			g.setColor(Graphics.getColorOfName(Graphics.SILVER));
			g.fillRect(left, top, 128, 128);
			g.drawImage(map.letter[map.getLetter("s")],left+4,top+24);
			g.drawImage(map.letter[map.getLetter("c")],left+28,top+24);
			g.drawImage(map.letter[map.getLetter("o")],left+52,top+24);
			g.drawImage(map.letter[map.getLetter("r")],left+76,top+24);
			g.drawImage(map.letter[map.getLetter("e")],left+100,top+24);
			for(n=0;n<4;++n){ // XRA̕`
				k = sc.getNum(4-n,0);
				if(k != 11){
					g.drawImage(map.num[k],left+8+24*n,top+68);
				}
			}
		}else if(gstatus == GAME_OVER){
			++count;
			if(count > 36){ count = -6;}

			k = left + 88 - count*8;
			g.drawImage(map.back3,left,top);
			g.drawImage(map.letter[map.getLetter("g")],k,top+4);
			g.drawImage(map.letter[map.getLetter("a")],k+24,top+4);
			g.drawImage(map.letter[map.getLetter("m")],k+48,top+4);
			g.drawImage(map.letter[map.getLetter("e")],k+72,top+4);
			g.drawImage(map.letter[map.getLetter("o")],k+96,top+4);
			g.drawImage(map.letter[map.getLetter("v")],k+120,top+4);
			g.drawImage(map.letter[map.getLetter("e")],k+144,top+4);
			g.drawImage(map.letter[map.getLetter("r")],k+168,top+4);

			g.setColor(Graphics.getColorOfName(Graphics.WHITE));
			g.fillRect(left+128, top, left, 30); //͂ݏoh~
			g.fillRect(0, top, left, 30); //͂ݏoh~
		}else if(gstatus == GAME_HISCORE){
			g.setColor(Graphics.getColorOfName(Graphics.SILVER));
			g.fillRect(left, top, 128, 128);
			g.drawImage(map.letter[map.getLetter("h")],left+16,top+16);
			g.drawImage(map.letter[map.getLetter("i")],left+40,top+16);
			g.drawImage(map.letter[map.getLetter("g")],left+64,top+16);
			g.drawImage(map.letter[map.getLetter("h")],left+88,top+16);
			g.drawImage(map.letter[map.getLetter("s")],left+4,top+40);
			g.drawImage(map.letter[map.getLetter("c")],left+28,top+40);
			g.drawImage(map.letter[map.getLetter("o")],left+52,top+40);
			g.drawImage(map.letter[map.getLetter("r")],left+76,top+40);
			g.drawImage(map.letter[map.getLetter("e")],left+100,top+40);
			for(n=0;n<4;++n){ // XRA̕`
				k = sc.getNum(4-n,1);
				if(k != 11){
					g.drawImage(map.num[k],left+8+24*n,top+80);
				}
			}
		}else{
			g.drawImage(map.back2,left,top); // wi̕`
			for(n=0;n<3;++n){ // XRA̕`
				k = sc.getNum(3-n,0);
				if(k != 11){
					g.drawImage(map.numi[k],left+80+16*n,top);
				}
			}
			for(n=0;n<pl.shita;++n){ // ̂艺~̕`
				g.drawImage(map.copic[6],left+16*n,top);
			}
			g.drawImage(map.numi[pl.hearts],left+4,top+12); // ̂Life̕`
			if(gstatus == GAME_DAMAGE){ // EvC[
				g.drawImage(pl.plpic[pl.getPlpat()],left+pl.getChpos(),top+84); // vC[̕`
				pl.anime = 0;
				if(time0 > 16){ g.drawImage(pl.kemu[0],left+pl.getChpos(),top+68);} // ̕`
				else{ g.drawImage(pl.kemu[1],left+pl.getChpos(),top+68);}
			}
			else{
				if(pl.sstatus){ // ~gĂƂ
					if((gstatus == GAME_PLAY)&(pl.scount > 0)){ pl.mSCount();}
					if(pl.scount > 3){ g.drawImage(pl.kemu[0],left+pl.getChpos(),top+68);} // ̕`
					else if(pl.scount > 0){ g.drawImage(pl.kemu[1],left+pl.getChpos(),top+68);}

					g.drawImage(pl.plpic2,left+pl.getChpos(),top+80); // vC[̕`
				}else{ // ~gĂȂƂ
					g.drawImage(pl.plpic[pl.getPlpat()],left+pl.getChpos(),top+84); // vC[̕`
				}
			}

			if((t1.vi)&(t1.dist < 7)){ //`[N̕`
				k = t1.dist;
				if(k == 6){ k = 5;}
				g.drawImage(map.copic[t1.lpos*5+5-k],left+t1.getChPos()*4,top+t1.getCvPos()*4);
			}
			if((t2.vi)&(t2.dist < 7)){
				k = t2.dist;
				if(k == 6){ k = 5;}
				g.drawImage(map.copic[t2.lpos*5+5-k],left+t2.getChPos()*4,top+t2.getCvPos()*4);
			}
			if((t3.vi)&(t3.dist < 7)){
				k = t3.dist;
				if(k == 6){ k = 5;}
				g.drawImage(map.copic[t3.lpos*5+5-k],left+t3.getChPos()*4,top+t3.getCvPos()*4);
			}
		}
		g.unlock(true);
	}

	private void setTama(){
		if(sc.score < 20){
			setTama2(pl.ppos, 5+getRandomInt(2));
			tcount = 26+getRandomInt(11);
		}else if(sc.score < 30){
			setTama2(pl.ppos, 4+getRandomInt(3));
			tcount = 20+getRandomInt(11);
		}else if(sc.score < 50){
			setTama2(pl.ppos, 4+getRandomInt(2));
			tcount = 15+getRandomInt(11);
		}else if(sc.score < 65){
			setTama2(pl.ppos, 4+getRandomInt(2));
			tcount = 10+getRandomInt(13);
		}else if(sc.score < 80){
			setTama2(pl.ppos, 4);
			tcount = 9+getRandomInt(10);
		}else if(sc.score < 100){
			setTama2(pl.ppos, 3+getRandomInt(3));
			tcount = 8+getRandomInt(9);
		}else if(sc.score < 150){
			setTama2(pl.ppos, 3+getRandomInt(2));
			tcount = 6+getRandomInt(8);
		}else if(sc.score < 280){
			setTama2(pl.ppos, 3+getRandomInt(2));
			tcount = 5+getRandomInt(7);
		}else if(sc.score < 350){
			setTama2(pl.ppos, 3+getRandomInt(3)/2);
			tcount = 4+getRandomInt(5);
		}else if(sc.score < 450){
			setTama2(pl.ppos, 3+getRandomInt(4)/3);
			tcount = 3+getRandomInt(5);
		}else{
			setTama2(pl.ppos, 3+getRandomInt(5)/4);
			tcount = 3+getRandomInt(4);
		}
		
	}

	private void setTama2(int l, int u){
		int npos;
		if(backpos == l){ npos=getOtherDir1(backpos); }
		else{ npos = l;}

		if(!(t1.vi)){ t1.makeTamad(npos, u); ++nc;}
		else if(!(t2.vi)){ t2.makeTamad(npos, u); ++nc;}
		else if(!(t3.vi)){ t3.makeTamad(npos, u); ++nc;}
		backpos = npos;
	}

	private static int getOtherDir1(int u){
		int i = getRandomInt(2);
		if(u == 1){
			if(i==1){ i=2;}
		}else if(u == 0){
			++i;
		}
		return i;
	}

	private static int getOtherDir2(int u, int v){
		int i;
		for(i=0;i<3;++i){
			if((i!=u)&(i!=v)){break;}
		}
		return i;
	}

	private static int getRandomInt(int n){
		return Math.abs(rnd.nextInt() % n);
	}

	public void processEvent(int type, int param){
		int key = getKeypadState();

		if(type == Display.KEY_PRESSED_EVENT){
			if(param == Display.KEY_SOFT1){
				if(gstatus == GAME_PLAY){
					setSoftLabel(SOFT_KEY_1, "Play");
					time0 = 70;
					gstatus = GAME_OPEN;
				}else if(gstatus == GAME_OPEN){
					setSoftLabel(SOFT_KEY_1, "");
					gstatus = GAME_PLAY;
					pl.reset();
					sc.reset();
					pl.softreset();
					t1.vi = false;
					t2.vi = false;
					t3.vi = false;
					sc.loadScore();
					time0 = 0;
					tcount = 30;
					count = 0;
				}else if(gstatus == GAME_DAMAGE){
					gstatus = GAME_OPEN;
					setSoftLabel(SOFT_KEY_1, "Play");
					time0 = 70;
				}else if((gstatus == GAME_HISCORE)|(gstatus == GAME_SCORE)){
					time0 = 0;
				}else if(gstatus == GAME_OVER){
					gstatus = GAME_SCORE;
					sc.score *= 3;
					sc.hsCheck();
					time0 = 40;
				}
			}else if(param == Display.KEY_SOFT2){
				IApplication.getCurrentApp().terminate();
			}else if((param == Display.KEY_LEFT)|(param == Display.KEY_4)){
				if(gstatus == GAME_PLAY){
					pl.mleft();
				}
			}else if((param == Display.KEY_SELECT)|(param == Display.KEY_5)){
				if(gstatus == GAME_PLAY){
					pl.setShita();
				}
			}else if((param == Display.KEY_RIGHT)|(param == Display.KEY_6)){
				if(gstatus == GAME_PLAY){
					pl.mright();
				}
			}else if(param == Display.KEY_0){
				if(gstatus == GAME_PLAY){
					gstatus = GAME_PAUSE;
				}else if(gstatus == GAME_PAUSE){
					gstatus = GAME_PLAY;
				}
			}
		}
		else{
			if((param == Display.KEY_5)|(param == Display.KEY_SELECT)){
				if(gstatus == GAME_PLAY){
					pl.sstatus = false;
				}
			}
		}
	}
}
